// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlShortcutAccelDialog")]
    pub struct ShortcutAccelDialog(Object<ffi::DzlShortcutAccelDialog, ffi::DzlShortcutAccelDialogClass>) @extends gtk::Dialog, gtk::Window, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_shortcut_accel_dialog_get_type(),
    }
}

impl ShortcutAccelDialog {
    #[doc(alias = "dzl_shortcut_accel_dialog_new")]
    pub fn new() -> ShortcutAccelDialog {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_shortcut_accel_dialog_new()).unsafe_cast() }
    }

    #[doc(alias = "dzl_shortcut_accel_dialog_get_accelerator")]
    #[doc(alias = "get_accelerator")]
    pub fn accelerator(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_full(ffi::dzl_shortcut_accel_dialog_get_accelerator(
                self.to_glib_none().0,
            ))
        }
    }

    //#[doc(alias = "dzl_shortcut_accel_dialog_get_chord")]
    //#[doc(alias = "get_chord")]
    //pub fn chord(&self) -> /*Ignored*/Option<ShortcutChord> {
    //    unsafe { TODO: call ffi:dzl_shortcut_accel_dialog_get_chord() }
    //}

    #[doc(alias = "dzl_shortcut_accel_dialog_get_shortcut_title")]
    #[doc(alias = "get_shortcut_title")]
    pub fn shortcut_title(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_shortcut_accel_dialog_get_shortcut_title(
                self.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_shortcut_accel_dialog_set_accelerator")]
    pub fn set_accelerator(&self, accelerator: &str) {
        unsafe {
            ffi::dzl_shortcut_accel_dialog_set_accelerator(
                self.to_glib_none().0,
                accelerator.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_shortcut_accel_dialog_set_shortcut_title")]
    pub fn set_shortcut_title(&self, title: &str) {
        unsafe {
            ffi::dzl_shortcut_accel_dialog_set_shortcut_title(
                self.to_glib_none().0,
                title.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "accelerator")]
    pub fn connect_accelerator_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_accelerator_trampoline<
            F: Fn(&ShortcutAccelDialog) + 'static,
        >(
            this: *mut ffi::DzlShortcutAccelDialog,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::accelerator\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_accelerator_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "shortcut-title")]
    pub fn connect_shortcut_title_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_shortcut_title_trampoline<
            F: Fn(&ShortcutAccelDialog) + 'static,
        >(
            this: *mut ffi::DzlShortcutAccelDialog,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::shortcut-title\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_shortcut_title_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl Default for ShortcutAccelDialog {
    fn default() -> Self {
        Self::new()
    }
}

impl fmt::Display for ShortcutAccelDialog {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("ShortcutAccelDialog")
    }
}
